# Uses of Class
javax.swing.undo.CannotUndoException

Packages that use CannotUndoException
Package
Description
javax.swing.text
Provides classes and interfaces that deal with editable and noneditable text components.
javax.swing.undo
Allows developers to provide support for undo/redo in applications such as text editors.

## Uses of CannotUndoException in javax.swing.text

Methods in javax.swing.text that throw CannotUndoException
Modifier and Type
Method
Description
`void`
AbstractDocument.DefaultDocumentEvent.`undo()`
Undoes a change.
`void`
AbstractDocument.ElementEdit.`undo()`
Undoes a change.
`void`
DefaultStyledDocument.AttributeUndoableEdit.`undo()`
Undoes a change.

## Uses of CannotUndoException in javax.swing.undo

Methods in javax.swing.undo that throw CannotUndoException
Modifier and Type
Method
Description
`void`
AbstractUndoableEdit.`undo()`
Throws `CannotUndoException` if `canUndo` returns `false`.
`void`
CompoundEdit.`undo()`
Sends `undo` to all contained `UndoableEdits` in the reverse of the order in which they were added.
`void`
UndoableEdit.`undo()`
Undo the edit.
`void`
UndoManager.`undo()`
Undoes the appropriate edits.
`void`
UndoManager.`undoOrRedo()`
Convenience method that invokes one of `undo` or `redo`.
`protected void`
UndoManager.`undoTo(UndoableEdit edit)`
Undoes all changes from the index of the next edit to `edit`, updating the index of the next edit appropriately.